AutoBanishPets = AutoBanishPets or {}
local AutoBanishPets = AutoBanishPets

function AutoBanishPets.CreateSettingsWindow()
    local LAM2 = LibAddonMenu2
    local panelData = {
        type = "panel",
        name = "Auto Banish Pets",
        displayName = "Auto Banish Pets/Assistants/Companions",
        author = "@tdenc",
        version = AutoBanishPets.version,
        registerForRefresh = true,
        registerForDefaults = true,
        website = "https://www.esoui.com/downloads/info3099-AutoBanishPets.html",
    }
    local cntrlOptionsPanel = LAM2:RegisterAddonPanel("AutoBanishPets_Settings", panelData)

    local selectOptions = {
        [1] = GetString(ABP_SELECT_OPTION1),
        [2] = GetString(ABP_SELECT_OPTION2),
        [3] = GetString(ABP_SELECT_OPTION3),
    }
    local selectOptionValues = {
        [1] = 1,
        [2] = 2,
        [3] = 3,
    }
    local companionNames = {
        [1] = ZO_CachedStrFormat("<<1>>", GetCollectibleName(AutoBanishPets.companions[1])),
        [2] = ZO_CachedStrFormat("<<1>>", GetCollectibleName(AutoBanishPets.companions[2])),
        [3] = ZO_CachedStrFormat("<<1>>", GetCollectibleName(AutoBanishPets.companions[3])),
        [4] = ZO_CachedStrFormat("<<1>>", GetCollectibleName(AutoBanishPets.companions[4])),
        [5] = ZO_CachedStrFormat("<<1>>", GetCollectibleName(AutoBanishPets.companions[5])),
        [6] = ZO_CachedStrFormat("<<1>>", GetCollectibleName(AutoBanishPets.companions[6])),
    }

    local dislikeLocationNames = {
        [1] = "",
        [2] = "",
        [3] = "",
        [4] = "",
        [5] = "",
        [6] = "",
    }
    for index, id in pairs(AutoBanishPets.companions) do
        for zoneId, _ in pairs(AutoBanishPets.locations[id]) do
            dislikeLocationNames[index] = string.format("%s %s,", dislikeLocationNames[index], GetZoneNameById(zoneId))
        end
        if dislikeLocationNames[index] ~= "" then
            dislikeLocationNames[index] = string.sub(dislikeLocationNames[index], 2, -2) -- strip
        end
    end

    local dS = AutoBanishPets.defaultSettings
    local sV = AutoBanishPets.savedVariables
    local optionsData = {
        {
            type = "header",
            name = GetString(ABP_WHEN_NAME),
            width = "full",
        },
        {
            type = "submenu", name = GetString(ABP_PETS_NAME), controls = {
                {
                    type = "checkbox",
                    name = GetString(ABP_NO_PETS_ALLOWED_NAME),
                    tooltip = GetString(ABP_NO_PETS_ALLOWED_TOOLTIP),
                    default = dS.noPetsAllowed,
                    requiresReload = false,
                    getFunc = function() return sV.noPetsAllowed end,
                    setFunc = function(newValue)
                        AutoBanishPets.ToggleNPA(newValue)
                        sV.noPetsAllowed = newValue
                    end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_BANK_NAME),
                    tooltip = GetString(ABP_BANK_TOOLTIP),
                    default = dS.bank.pets,
                    requiresReload = false,
                    getFunc = function() return sV.bank.pets end,
                    setFunc = function(newValue) sV.bank.pets = newValue end,
                    disabled = function() return sV.noPetsAllowed end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_GUILD_BANK_NAME),
                    tooltip = GetString(ABP_GUILD_BANK_TOOLTIP),
                    default = dS.guildBank.pets,
                    requiresReload = false,
                    getFunc = function() return sV.guildBank.pets end,
                    setFunc = function(newValue) sV.guildBank.pets = newValue end,
                    disabled = function() return sV.noPetsAllowed end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_STORE_NAME),
                    tooltip = GetString(ABP_STORE_TOOLTIP),
                    default = dS.store.pets,
                    requiresReload = false,
                    getFunc = function() return sV.store.pets end,
                    setFunc = function(newValue) sV.store.pets = newValue end,
                    disabled = function() return sV.noPetsAllowed end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_GUILD_STORE_NAME),
                    tooltip = GetString(ABP_GUILD_STORE_TOOLTIP),
                    default = dS.guildStore.pets,
                    requiresReload = false,
                    getFunc = function() return sV.guildStore.pets end,
                    setFunc = function(newValue) sV.guildStore.pets = newValue end,
                    disabled = function() return sV.noPetsAllowed end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_FENCE_NAME),
                    tooltip = GetString(ABP_FENCE_TOOLTIP),
                    default = dS.fence.pets,
                    requiresReload = false,
                    getFunc = function() return sV.fence.pets end,
                    setFunc = function(newValue) sV.fence.pets = newValue end,
                    disabled = function() return sV.noPetsAllowed end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_CRAFT_STATION_NAME),
                    tooltip = GetString(ABP_CRAFT_STATION_TOOLTIP),
                    default = dS.craftStation.pets,
                    requiresReload = false,
                    getFunc = function() return sV.craftStation.pets end,
                    setFunc = function(newValue) sV.craftStation.pets = newValue end,
                    disabled = function() return sV.noPetsAllowed end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_RETRAIT_STATION_NAME),
                    tooltip = GetString(ABP_RETRAIT_STATION_TOOLTIP),
                    default = dS.retraitStation.pets,
                    requiresReload = false,
                    getFunc = function() return sV.retraitStation.pets end,
                    setFunc = function(newValue) sV.retraitStation.pets = newValue end,
                    disabled = function() return sV.noPetsAllowed end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_DYEING_STATION_NAME),
                    tooltip = GetString(ABP_DYEING_STATION_TOOLTIP),
                    default = dS.dyeingStation.pets,
                    requiresReload = false,
                    getFunc = function() return sV.dyeingStation.pets end,
                    setFunc = function(newValue) sV.dyeingStation.pets = newValue end,
                    disabled = function() return sV.noPetsAllowed end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_WAYSHRINE_NAME),
                    tooltip = GetString(ABP_WAYSHRINE_TOOLTIP),
                    default = dS.wayshrine.pets,
                    requiresReload = false,
                    getFunc = function() return sV.wayshrine.pets end,
                    setFunc = function(newValue) sV.wayshrine.pets = newValue end,
                    disabled = function() return sV.noPetsAllowed end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_QUEST_NAME),
                    tooltip = GetString(ABP_QUEST_TOOLTIP),
                    default = dS.quest.pets,
                    requiresReload = false,
                    getFunc = function() return sV.quest.pets end,
                    setFunc = function(newValue) sV.quest.pets = newValue end,
                    disabled = function() return sV.noPetsAllowed end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_STEALTH_NAME),
                    tooltip = GetString(ABP_STEALTH_TOOLTIP),
                    default = dS.stealth.pets,
                    requiresReload = false,
                    getFunc = function() return sV.stealth.pets end,
                    setFunc = function(newValue) sV.stealth.pets = newValue end,
                    disabled = function() return sV.noPetsAllowed end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_AFTER_COMBAT_NAME),
                    tooltip = GetString(ABP_AFTER_COMBAT_TOOLTIP),
                    default = dS.combat.pets,
                    requiresReload = false,
                    getFunc = function() return sV.combat.pets end,
                    setFunc = function(newValue) sV.combat.pets = newValue end,
                    disabled = function() return sV.noPetsAllowed end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_LOGOUT_NAME),
                    tooltip = GetString(ABP_LOGOUT_TOOLTIP),
                    default = dS.logout.pets,
                    requiresReload = true,
                    getFunc = function() return sV.logout.pets end,
                    setFunc = function(newValue) sV.logout.pets = newValue end,
                    disabled = function() return sV.noPetsAllowed end,
                },
            }
        },
        {
            type = "submenu", name = GetString(ABP_VANITY_PETS_NAME), controls = {
                {
                    type = "checkbox",
                    name = GetString(ABP_BANK_NAME),
                    tooltip = GetString(ABP_BANK_TOOLTIP),
                    default = dS.bank.vanityPets,
                    requiresReload = false,
                    getFunc = function() return sV.bank.vanityPets end,
                    setFunc = function(newValue) sV.bank.vanityPets = newValue end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_GUILD_BANK_NAME),
                    tooltip = GetString(ABP_GUILD_BANK_TOOLTIP),
                    default = dS.guildBank.vanityPets,
                    requiresReload = false,
                    getFunc = function() return sV.guildBank.vanityPets end,
                    setFunc = function(newValue) sV.guildBank.vanityPets = newValue end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_STORE_NAME),
                    tooltip = GetString(ABP_STORE_TOOLTIP),
                    default = dS.store.vanityPets,
                    requiresReload = false,
                    getFunc = function() return sV.store.vanityPets end,
                    setFunc = function(newValue) sV.store.vanityPets = newValue end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_GUILD_STORE_NAME),
                    tooltip = GetString(ABP_GUILD_STORE_TOOLTIP),
                    default = dS.guildStore.vanityPets,
                    requiresReload = false,
                    getFunc = function() return sV.guildStore.vanityPets end,
                    setFunc = function(newValue) sV.guildStore.vanityPets = newValue end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_FENCE_NAME),
                    tooltip = GetString(ABP_FENCE_TOOLTIP),
                    default = dS.fence.vanityPets,
                    requiresReload = false,
                    getFunc = function() return sV.fence.vanityPets end,
                    setFunc = function(newValue) sV.fence.vanityPets = newValue end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_CRAFT_STATION_NAME),
                    tooltip = GetString(ABP_CRAFT_STATION_TOOLTIP),
                    default = dS.craftStation.vanityPets,
                    requiresReload = false,
                    getFunc = function() return sV.craftStation.vanityPets end,
                    setFunc = function(newValue) sV.craftStation.vanityPets = newValue end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_RETRAIT_STATION_NAME),
                    tooltip = GetString(ABP_RETRAIT_STATION_TOOLTIP),
                    default = dS.retraitStation.vanityPets,
                    requiresReload = false,
                    getFunc = function() return sV.retraitStation.vanityPets end,
                    setFunc = function(newValue) sV.retraitStation.vanityPets = newValue end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_DYEING_STATION_NAME),
                    tooltip = GetString(ABP_DYEING_STATION_TOOLTIP),
                    default = dS.dyeingStation.vanityPets,
                    requiresReload = false,
                    getFunc = function() return sV.dyeingStation.vanityPets end,
                    setFunc = function(newValue) sV.dyeingStation.vanityPets = newValue end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_WAYSHRINE_NAME),
                    tooltip = GetString(ABP_WAYSHRINE_TOOLTIP),
                    default = dS.wayshrine.vanityPets,
                    requiresReload = false,
                    getFunc = function() return sV.wayshrine.vanityPets end,
                    setFunc = function(newValue) sV.wayshrine.vanityPets = newValue end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_QUEST_NAME),
                    tooltip = GetString(ABP_QUEST_TOOLTIP),
                    default = dS.quest.vanityPets,
                    requiresReload = false,
                    getFunc = function() return sV.quest.vanityPets end,
                    setFunc = function(newValue) sV.quest.vanityPets = newValue end,
                },
                {
                    type = "dropdown",
                    name = GetString(ABP_STEALTH_NAME),
                    tooltip = GetString(ABP_STEALTH_TOOLTIP),
                    default = dS.stealth.vanityPets,
                    requiresReload = false,
                    choices = selectOptions,
                    choicesValues = selectOptionValues,
                    getFunc = function() return sV.stealth.vanityPets end,
                    setFunc = function(newValue) sV.stealth.vanityPets = newValue end,
                },
                {
                    type = "dropdown",
                    name = GetString(ABP_BEFORE_COMBAT_NAME),
                    tooltip = GetString(ABP_BEFORE_COMBAT_TOOLTIP),
                    default = dS.combat.vanityPets,
                    requiresReload = false,
                    choices = selectOptions,
                    choicesValues = selectOptionValues,
                    getFunc = function() return sV.combat.vanityPets end,
                    setFunc = function(newValue) sV.combat.vanityPets = newValue end,
                },
            }
        },
        {
            type = "submenu", name = GetString(ABP_ASSISTANTS_NAME), controls = {
                {
                    type = "checkbox",
                    name = GetString(ABP_GUILD_BANK_NAME),
                    tooltip = GetString(ABP_GUILD_BANK_TOOLTIP),
                    default = dS.guildBank.assistants,
                    requiresReload = false,
                    getFunc = function() return sV.guildBank.assistants end,
                    setFunc = function(newValue) sV.guildBank.assistants = newValue end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_GUILD_STORE_NAME),
                    tooltip = GetString(ABP_GUILD_STORE_TOOLTIP),
                    default = dS.guildStore.assistants,
                    requiresReload = false,
                    getFunc = function() return sV.guildStore.assistants end,
                    setFunc = function(newValue) sV.guildStore.assistants = newValue end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_CRAFT_STATION_NAME),
                    tooltip = GetString(ABP_CRAFT_STATION_TOOLTIP),
                    default = dS.craftStation.assistants,
                    requiresReload = false,
                    getFunc = function() return sV.craftStation.assistants end,
                    setFunc = function(newValue) sV.craftStation.assistants = newValue end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_RETRAIT_STATION_NAME),
                    tooltip = GetString(ABP_RETRAIT_STATION_TOOLTIP),
                    default = dS.retraitStation.assistants,
                    requiresReload = false,
                    getFunc = function() return sV.retraitStation.assistants end,
                    setFunc = function(newValue) sV.retraitStation.assistants = newValue end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_DYEING_STATION_NAME),
                    tooltip = GetString(ABP_DYEING_STATION_TOOLTIP),
                    default = dS.dyeingStation.assistants,
                    requiresReload = false,
                    getFunc = function() return sV.dyeingStation.assistants end,
                    setFunc = function(newValue) sV.dyeingStation.assistants = newValue end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_WAYSHRINE_NAME),
                    tooltip = GetString(ABP_WAYSHRINE_TOOLTIP),
                    default = dS.wayshrine.assistants,
                    requiresReload = false,
                    getFunc = function() return sV.wayshrine.assistants end,
                    setFunc = function(newValue) sV.wayshrine.assistants = newValue end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_QUEST_NAME),
                    tooltip = GetString(ABP_QUEST_TOOLTIP),
                    default = dS.quest.assistants,
                    requiresReload = false,
                    getFunc = function() return sV.quest.assistants end,
                    setFunc = function(newValue) sV.quest.assistants = newValue end,
                },
                {
                    type = "dropdown",
                    name = GetString(ABP_STEALTH_NAME),
                    tooltip = GetString(ABP_STEALTH_TOOLTIP),
                    default = dS.stealth.assistants,
                    requiresReload = false,
                    choices = selectOptions,
                    choicesValues = selectOptionValues,
                    getFunc = function() return sV.stealth.assistants end,
                    setFunc = function(newValue) sV.stealth.assistants = newValue end,
                },
                {
                    type = "dropdown",
                    name = GetString(ABP_BEFORE_COMBAT_NAME),
                    tooltip = GetString(ABP_BEFORE_COMBAT_TOOLTIP),
                    default = dS.combat.assistants,
                    requiresReload = false,
                    choices = selectOptions,
                    choicesValues = selectOptionValues,
                    getFunc = function() return sV.combat.assistants end,
                    setFunc = function(newValue) sV.combat.assistants = newValue end,
                },
                {
                    type = "checkbox",
                    name = GetString(ABP_EXIT_NAME),
                    tooltip = GetString(ABP_EXIT_TOOLTIP),
                    default = dS.exit,
                    requiresReload = false,
                    getFunc = function() return sV.exit end,
                    setFunc = function(newValue) sV.exit = newValue end,
                },
            }
        },
        {
            type = "submenu", name = GetString(ABP_COMPANIONS_NAME), controls = {
                {
                    type = "header",
                    name = GetString(ABP_BANK_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.bank[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    getFunc = function() return sV.bank[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.bank[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.bank[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    getFunc = function() return sV.bank[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.bank[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.bank[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.bank[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.bank[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.bank[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.bank[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.bank[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.bank[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.bank[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.bank[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.bank[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.bank[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.bank[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_GUILD_BANK_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.guildBank[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    getFunc = function() return sV.guildBank[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.guildBank[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.guildBank[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    getFunc = function() return sV.guildBank[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.guildBank[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.guildBank[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.guildBank[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.guildBank[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.guildBank[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.guildBank[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.guildBank[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.guildBank[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    getFunc = function() return sV.guildBank[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.guildBank[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.guildBank[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    getFunc = function() return sV.guildBank[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.guildBank[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_STORE_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.store[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    getFunc = function() return sV.store[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.store[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.store[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    getFunc = function() return sV.store[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.store[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.store[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.store[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.store[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.store[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.store[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.store[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.store[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    getFunc = function() return sV.store[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.store[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.store[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    getFunc = function() return sV.store[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.store[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_GUILD_STORE_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.guildStore[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    getFunc = function() return sV.guildStore[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.guildStore[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.guildStore[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    getFunc = function() return sV.guildStore[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.guildStore[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.guildStore[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.guildStore[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.guildStore[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.guildStore[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.guildStore[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.guildStore[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.guildStore[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    getFunc = function() return sV.guildStore[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.guildStore[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.guildStore[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    getFunc = function() return sV.guildStore[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.guildStore[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_FENCE_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.fence[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    getFunc = function() return sV.fence[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.fence[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.fence[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    getFunc = function() return sV.fence[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.fence[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.fence[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.fence[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.fence[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.fence[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.fence[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.fence[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.fence[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    getFunc = function() return sV.fence[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.fence[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.fence[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    getFunc = function() return sV.fence[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.fence[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_CRAFT_STATION_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.craftStation[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    getFunc = function() return sV.craftStation[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.craftStation[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.craftStation[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    getFunc = function() return sV.craftStation[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.craftStation[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.craftStation[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.craftStation[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.craftStation[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.craftStation[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.craftStation[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.craftStation[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.craftStation[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    getFunc = function() return sV.craftStation[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.craftStation[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.craftStation[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    getFunc = function() return sV.craftStation[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.craftStation[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_RETRAIT_STATION_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.retraitStation[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    getFunc = function() return sV.retraitStation[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.retraitStation[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.retraitStation[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    getFunc = function() return sV.retraitStation[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.retraitStation[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.retraitStation[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.retraitStation[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.retraitStation[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.retraitStation[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.retraitStation[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.retraitStation[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.retraitStation[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    getFunc = function() return sV.retraitStation[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.retraitStation[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.retraitStation[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    getFunc = function() return sV.retraitStation[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.retraitStation[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_DYEING_STATION_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.dyeingStation[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    getFunc = function() return sV.dyeingStation[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.dyeingStation[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.dyeingStation[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    getFunc = function() return sV.dyeingStation[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.dyeingStation[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.dyeingStation[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.dyeingStation[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.dyeingStation[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.dyeingStation[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.dyeingStation[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.dyeingStation[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.dyeingStation[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    getFunc = function() return sV.dyeingStation[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.dyeingStation[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.dyeingStation[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    getFunc = function() return sV.dyeingStation[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.dyeingStation[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_PROVISIONING_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.provisioning[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    getFunc = function() return sV.provisioning[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.provisioning[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.provisioning[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    getFunc = function() return sV.provisioning[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.provisioning[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.provisioning[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.provisioning[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.provisioning[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.provisioning[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.provisioning[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.provisioning[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.provisioning[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    getFunc = function() return sV.provisioning[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.provisioning[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.provisioning[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    getFunc = function() return sV.provisioning[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.provisioning[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_WAYSHRINE_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.wayshrine[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    getFunc = function() return sV.wayshrine[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.wayshrine[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.wayshrine[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    getFunc = function() return sV.wayshrine[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.wayshrine[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.wayshrine[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.wayshrine[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.wayshrine[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.wayshrine[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.wayshrine[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.wayshrine[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.wayshrine[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    getFunc = function() return sV.wayshrine[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.wayshrine[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.wayshrine[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    getFunc = function() return sV.wayshrine[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.wayshrine[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_HARVESTING_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.harvesting[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    getFunc = function() return sV.harvesting[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.harvesting[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.harvesting[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    getFunc = function() return sV.harvesting[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.harvesting[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.harvesting[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.harvesting[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.harvesting[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.harvesting[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.harvesting[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.harvesting[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.harvesting[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    getFunc = function() return sV.harvesting[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.harvesting[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.harvesting[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    getFunc = function() return sV.harvesting[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.harvesting[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_THIEVESTROVE_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.thievesTrove[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    getFunc = function() return sV.thievesTrove[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.thievesTrove[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.thievesTrove[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    getFunc = function() return sV.thievesTrove[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.thievesTrove[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.thievesTrove[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.thievesTrove[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.thievesTrove[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.thievesTrove[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.thievesTrove[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.thievesTrove[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.thievesTrove[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    getFunc = function() return sV.thievesTrove[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.thievesTrove[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.thievesTrove[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    getFunc = function() return sV.thievesTrove[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.thievesTrove[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_STEAL_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.steal[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    getFunc = function() return sV.steal[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.steal[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.steal[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    getFunc = function() return sV.steal[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.steal[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.steal[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.steal[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.steal[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.steal[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.steal[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.steal[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.steal[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    getFunc = function() return sV.steal[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.steal[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.steal[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    getFunc = function() return sV.steal[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.steal[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_VAMPIRE_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.vampire[AutoBanishPets.companions[1]],
                    requiresReload = true,
                    getFunc = function() return sV.vampire[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.vampire[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.vampire[AutoBanishPets.companions[2]],
                    requiresReload = true,
                    getFunc = function() return sV.vampire[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.vampire[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.vampire[AutoBanishPets.companions[3]],
                    requiresReload = true,
                    getFunc = function() return sV.vampire[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.vampire[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.vampire[AutoBanishPets.companions[4]],
                    requiresReload = true,
                    getFunc = function() return sV.vampire[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.vampire[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.vampire[AutoBanishPets.companions[5]],
                    requiresReload = true,
                    getFunc = function() return sV.vampire[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.vampire[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.vampire[AutoBanishPets.companions[6]],
                    requiresReload = true,
                    getFunc = function() return sV.vampire[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.vampire[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_WEREWOLF_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.werewolf[AutoBanishPets.companions[1]],
                    requiresReload = true,
                    getFunc = function() return sV.werewolf[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.werewolf[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.werewolf[AutoBanishPets.companions[2]],
                    requiresReload = true,
                    getFunc = function() return sV.werewolf[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.werewolf[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.werewolf[AutoBanishPets.companions[3]],
                    requiresReload = true,
                    getFunc = function() return sV.werewolf[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.werewolf[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.werewolf[AutoBanishPets.companions[4]],
                    requiresReload = true,
                    getFunc = function() return sV.werewolf[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.werewolf[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.werewolf[AutoBanishPets.companions[5]],
                    requiresReload = true,
                    getFunc = function() return sV.werewolf[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.werewolf[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.werewolf[AutoBanishPets.companions[6]],
                    requiresReload = true,
                    getFunc = function() return sV.werewolf[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.werewolf[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_ARRESTED_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.arrested[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    getFunc = function() return sV.arrested[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.arrested[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.arrested[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    getFunc = function() return sV.arrested[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.arrested[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.arrested[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.arrested[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.arrested[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.arrested[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.arrested[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.arrested[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.arrested[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    getFunc = function() return sV.arrested[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.arrested[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.arrested[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    getFunc = function() return sV.arrested[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.arrested[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_FISHING_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.fishing[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    getFunc = function() return sV.fishing[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.fishing[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.fishing[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    getFunc = function() return sV.fishing[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.fishing[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.fishing[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.fishing[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.fishing[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.fishing[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.fishing[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.fishing[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.fishing[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    getFunc = function() return sV.fishing[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.fishing[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.fishing[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    getFunc = function() return sV.fishing[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.fishing[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_LOCATION_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    tooltip = dislikeLocationNames[1],
                    width = "half",
                    default = dS.location[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    disabled = function() return dislikeLocationNames[1] == "" end,
                    getFunc = function() return sV.location[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.location[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    tooltip = dislikeLocationNames[2],
                    width = "half",
                    default = dS.location[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    disabled = function() return dislikeLocationNames[2] == "" end,
                    getFunc = function() return sV.location[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.location[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    tooltip = dislikeLocationNames[3],
                    width = "half",
                    default = dS.location[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    disabled = function() return dislikeLocationNames[3] == "" end,
                    getFunc = function() return sV.location[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.location[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    tooltip = dislikeLocationNames[4],
                    width = "half",
                    default = dS.location[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    disabled = function() return dislikeLocationNames[4] == "" end,
                    getFunc = function() return sV.location[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.location[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    tooltip = dislikeLocationNames[5],
                    width = "half",
                    default = dS.location[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    disabled = function() return dislikeLocationNames[5] == "" end,
                    getFunc = function() return sV.location[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.location[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    tooltip = dislikeLocationNames[6],
                    width = "half",
                    default = dS.location[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    disabled = function() return dislikeLocationNames[6] == "" end,
                    getFunc = function() return sV.location[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.location[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_QUEST_NAME),
                    width = "full",
                },
                {
                    type = "checkbox",
                    name = companionNames[1],
                    width = "half",
                    default = dS.quest[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    getFunc = function() return sV.quest[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.quest[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[2],
                    width = "half",
                    default = dS.quest[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    getFunc = function() return sV.quest[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.quest[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[3],
                    width = "half",
                    default = dS.quest[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    getFunc = function() return sV.quest[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.quest[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[4],
                    width = "half",
                    default = dS.quest[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    getFunc = function() return sV.quest[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.quest[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[5],
                    width = "half",
                    default = dS.quest[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    getFunc = function() return sV.quest[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.quest[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "checkbox",
                    name = companionNames[6],
                    width = "half",
                    default = dS.quest[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    getFunc = function() return sV.quest[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.quest[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_STEALTH_NAME),
                    width = "full",
                },
                {
                    type = "dropdown",
                    name = companionNames[1],
                    width = "half",
                    default = dS.stealth.companions[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    choices = selectOptions,
                    choicesValues = selectOptionValues,
                    getFunc = function() return sV.stealth.companions[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.stealth.companions[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "dropdown",
                    name = companionNames[2],
                    width = "half",
                    default = dS.stealth.companions[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    choices = selectOptions,
                    choicesValues = selectOptionValues,
                    getFunc = function() return sV.stealth.companions[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.stealth.companions[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "dropdown",
                    name = companionNames[3],
                    width = "half",
                    default = dS.stealth.companions[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    choices = selectOptions,
                    choicesValues = selectOptionValues,
                    getFunc = function() return sV.stealth.companions[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.stealth.companions[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "dropdown",
                    name = companionNames[4],
                    width = "half",
                    default = dS.stealth.companions[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    choices = selectOptions,
                    choicesValues = selectOptionValues,
                    getFunc = function() return sV.stealth.companions[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.stealth.companions[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "dropdown",
                    name = companionNames[5],
                    width = "half",
                    default = dS.stealth.companions[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    choices = selectOptions,
                    choicesValues = selectOptionValues,
                    getFunc = function() return sV.stealth.companions[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.stealth.companions[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "dropdown",
                    name = companionNames[6],
                    width = "half",
                    default = dS.stealth.companions[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    choices = selectOptions,
                    choicesValues = selectOptionValues,
                    getFunc = function() return sV.stealth.companions[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.stealth.companions[AutoBanishPets.companions[6]] = newValue end,
                },
                {
                    type = "header",
                    name = GetString(ABP_AFTER_COMBAT_NAME),
                    width = "full",
                },
                {
                    type = "dropdown",
                    name = companionNames[1],
                    width = "half",
                    default = dS.combat.companions[AutoBanishPets.companions[1]],
                    requiresReload = false,
                    choices = selectOptions,
                    choicesValues = selectOptionValues,
                    getFunc = function() return sV.combat.companions[AutoBanishPets.companions[1]] end,
                    setFunc = function(newValue) sV.combat.companions[AutoBanishPets.companions[1]] = newValue end,
                },
                {
                    type = "dropdown",
                    name = companionNames[2],
                    width = "half",
                    default = dS.combat.companions[AutoBanishPets.companions[2]],
                    requiresReload = false,
                    choices = selectOptions,
                    choicesValues = selectOptionValues,
                    getFunc = function() return sV.combat.companions[AutoBanishPets.companions[2]] end,
                    setFunc = function(newValue) sV.combat.companions[AutoBanishPets.companions[2]] = newValue end,
                },
                {
                    type = "dropdown",
                    name = companionNames[3],
                    width = "half",
                    default = dS.combat.companions[AutoBanishPets.companions[3]],
                    requiresReload = false,
                    choices = selectOptions,
                    choicesValues = selectOptionValues,
                    getFunc = function() return sV.combat.companions[AutoBanishPets.companions[3]] end,
                    setFunc = function(newValue) sV.combat.companions[AutoBanishPets.companions[3]] = newValue end,
                },
                {
                    type = "dropdown",
                    name = companionNames[4],
                    width = "half",
                    default = dS.combat.companions[AutoBanishPets.companions[4]],
                    requiresReload = false,
                    choices = selectOptions,
                    choicesValues = selectOptionValues,
                    getFunc = function() return sV.combat.companions[AutoBanishPets.companions[4]] end,
                    setFunc = function(newValue) sV.combat.companions[AutoBanishPets.companions[4]] = newValue end,
                },
                {
                    type = "dropdown",
                    name = companionNames[5],
                    width = "half",
                    default = dS.combat.companions[AutoBanishPets.companions[5]],
                    requiresReload = false,
                    choices = selectOptions,
                    choicesValues = selectOptionValues,
                    getFunc = function() return sV.combat.companions[AutoBanishPets.companions[5]] end,
                    setFunc = function(newValue) sV.combat.companions[AutoBanishPets.companions[5]] = newValue end,
                },
                {
                    type = "dropdown",
                    name = companionNames[6],
                    width = "half",
                    default = dS.combat.companions[AutoBanishPets.companions[6]],
                    requiresReload = false,
                    choices = selectOptions,
                    choicesValues = selectOptionValues,
                    getFunc = function() return sV.combat.companions[AutoBanishPets.companions[6]] end,
                    setFunc = function(newValue) sV.combat.companions[AutoBanishPets.companions[6]] = newValue end,
                },
            },
        },
        {
            type = "header",
            name = GetString(ABP_GENERAL_NAME),
            width = "full",
        },
        {
            type = "checkbox",
            name = GetString(ABP_NOTIFICATION_NAME),
            default = dS.notification,
            requiresReload = false,
            getFunc = function() return sV.notification end,
            setFunc = function(newValue) sV.notification = newValue end,
        },
    }
    LAM2:RegisterOptionControls("AutoBanishPets_Settings", optionsData)
end